#if TODO
static void C_grp_load(void)
{
   char name[256];

   if (!FileDlg("Load group","Load","*.grp",name))
      return;

   NewMessage("Loading group %s...",name);
   Game.map.loadgroup(name);

   Cmd_SetRedraw(2);
}

static void C_grp_save(void)
{
   group_t *g;
   char name[256];

   g=GroupPicker();
   if (g)
   {
      if (!FileDlg("Save group","Save","*.grp",name))
         return;
      NewMessage("Saving group %s...",name);
      Game.map.savegroup(name,g);
   }
}

static const char T_pts_load[]=
"Load a .pts or .lin file and activates the display of it. .pts and .lin
files are generated by qbsp/qbsp3 when it encounters a leak in the map.
Each one contains information about a path through the map from the inside
to the outside. There's a leak somewhere along the line.
";
static void C_pts_load(void)
{
   char name[256],wc[16];

   strcpy(wc,"*");
   strcat(wc,Game.pts_ext);
   if (!FileDlg("Load point file","Load",wc,name))
      return;

   NewMessage("Loading '%s'...",name);
   ReadPts(name);

   Cmd_SetRedraw(2);
}
#endif


#if TODO
{"grp_load",C_grp_load,"Load a group."},
{"grp_save",C_grp_save,"Save a group."},
{"pts_load",C_pts_load,"Load a leak point (.pts/.lin) file.",T_pts_load},
#endif


#if TODO
static void C_brush_toggle_subtract(void)
{
   brushref_t *bs;
   int s;

   if (!M.display.num_bselected)
   {
      HandleError("brush_toggle_subtract",
         "Must have at least one brush selected!");
      return;
   }

   for (bs=M.display.bsel;bs;bs=bs->Next)
   {
      if ((bs->Brush->bt->type!=BR_NORMAL) && (bs->Brush->bt->type!=BR_SUBTRACT))
      {
         HandleError("brush_toggle_subtract",
            "Can't have non-normal brushes selected!");
         return;
      }
   }

   SUndo(UNDO_NONE,UNDO_CHANGE);

   if (M.display.bsel->Brush->bt->type==BR_NORMAL)
   {
      NewMessage("Selected brushes changed to subtractive.");
      s=BR_SUBTRACT;
   }
   else
   {
      NewMessage("Selected brushes changed to normal.");
      s=BR_NORMAL;
   }

   for (bs=M.display.bsel;bs;bs=bs->Next)
      B_ChangeType(bs->Brush,s);

   Cmd_SetRedraw(2);
}
#endif
#if TODO
{"brush_snap",C_brush_snap,"Snap selected brushes to grid."},
{"brush_snap_verts",C_brush_snap_verts,"Snap selected vertices to grid."},
{"brush_snap_to_vert",C_brush_snap_to_vert,"Snap selected vertices to a vertex."},
{"brush_toggle_subtract",C_brush_toggle_subtract,"Toggle selected brushes to/from subtractive."},
#endif


/* TODO: should't be here */
#if TODO
static void C_toggle_texlock(void)
{
   if (status.texlock)
      status.texlock=0;
   else
      status.texlock=1;

   NewMessage("Texture locking turned %s",
      status.texlock?"on":"off");
}
#endif

#if TODO
static void C_hide_all_but_sel(void)
{
   if (M.showsel)
   {
      M.showsel=0;
   }
   else
   {
      brush_t *b;
      entity_t *e;
      brushref_t *br;
      entityref_t *er;
      fsel_t *f;

      if (M.display.num_bselected ||
          M.display.num_eselected ||
          M.display.num_fselected)
      {
         M.showsel=1;

         for (b=M.BrushHead;b;b=b->Next)
            b->hidden=1;
         for (e=M.EntityHead;e;e=e->Next)
            e->hidden=1;

         for (br=M.display.bsel;br;br=br->Next)
            br->Brush->hidden=0;
         for (er=M.display.esel;er;er=er->Next)
            er->Entity->hidden=0;
         for (f=M.display.fsel;f;f=f->Next)
            f->Brush->hidden=0;
      }
      else
      {
         NewMessage("Nothing selected!");
      }
   }
   Cmd_SetRedraw(2);
}
#endif


#if TODO
static void C_toggle_grid(void)
{
   if (M.display.vport[M.display.active_vport].grid_type == NOGRID)
      M.display.vport[M.display.active_vport].grid_type = GRID;
   else
   if (M.display.vport[M.display.active_vport].grid_type == GRID)
      M.display.vport[M.display.active_vport].grid_type = ALIGN;
   else
/*	  if (M.display.vport[M.display.active_vport].grid_type == ALIGN)*/
      M.display.vport[M.display.active_vport].grid_type = NOGRID;
   Cmd_SetRedraw(2);
}
#endif

#if TODO
{"hide_all_but_sel",C_hide_all_but_sel,"Hide everything that isn't selected."},
#endif



void HandleLeftClickBrush(void)
{
	vsel_t     *v;
	vec3_t     *sel_vert;
	brush_t    *sel_brush;
	brushref_t *b;
	int         m_x,m_y;
	int         d_x, d_y;
	int         x_thresh, y_thresh;
	int         base_x, base_y;
   int         i;
	int         found;

	/* Click in active vport */
   if (TestKey(KEY_CONTROL) &&
       (TestKey(KEY_LF_SHIFT) || TestKey(KEY_RT_SHIFT)))
   {
      ClickBrush();
   }
   else
	if (TestKey(KEY_CONTROL))
	{
		sel_brush = SelectBrush(mouse.x, mouse.y);
		if (sel_brush != NULL)
		{
         b=FindSelBrush(sel_brush);
         if (b)
         {
            RemoveSelBrush(b);
			}
         else
			{
				AddSelBrush(sel_brush,1);
			}
		}
		else
		{
			base_x = mouse.x;
			base_y = mouse.y;
         SelectWindow();
			if ((mouse.x == base_x) && (mouse.y == base_y))
			{
				/* None, deselect all */
				ClearSelBrushes();
				ClearSelVerts();
			}
			else
         {
				SelectWindowBrush(base_x, base_y, mouse.x, mouse.y);
         }
		}

		/* Wait for let up of mouse, and redraw all vports */
		while (mouse.button==1) GetMousePos();
		UpdateAllViewports();
	}
	else
	if (TestKey(KEY_LF_SHIFT) || TestKey(KEY_RT_SHIFT))
	{
		sel_vert = FindVertex(M.display.active_vport, mouse.x, mouse.y);
		if (sel_vert != NULL)
		{
			/* Check if we're adding or removing */
         v=FindSelectVert(sel_vert);

         if (v)
         {
            /* Removing */
            found = TRUE;
            if (v->Last!=NULL) (v->Last)->Next = v->Next;
            if (v->Next!=NULL) (v->Next)->Last = v->Last;
            if (v==M.display.vsel) M.display.vsel=v->Next;

            Q_free(v);
            M.display.num_vselected--;
			}
         else
			{
            AddSelectVec(sel_vert);
			}
			while (mouse.button == 1)
				GetMousePos();
		}
		else
		{
			base_x = mouse.x;
			base_y = mouse.y;
         SelectWindow();
			/* Add all vertecies in window to selection list */
			if ((mouse.x == base_x) && (mouse.y == base_y))
			{
				ClearSelVerts();
			}
			else
         {
				SelectWindowVert(M.display.active_vport, base_x, base_y, mouse.x, mouse.y);
         }
		}
		while (mouse.button==1)
		   GetMousePos();
		UpdateAllViewports();

	}
	else
	{
		/* Check for vertex under mouse */
		sel_vert = FindVertex(M.display.active_vport, mouse.x, mouse.y);
		if (sel_vert == NULL)
		{
			/* None, deselect all vertices */
			ClearSelVerts();
			UpdateAllViewports();
		}
		else
		{
         v=FindSelectVert(sel_vert);
			if (!v)
			{
            AddSelectVec(sel_vert);
			}

			/* Now check for mouse drag */
			m_x = mouse.x;
			m_y = mouse.y;
			x_thresh = 2;
			y_thresh = 2;
			status.move = TRUE;
			status.move_amt.x = status.move_amt.y = status.move_amt.z = 0;
         i=0;
			while (mouse.button == 1)
			{
				QUI_RedrawWindow(STATUS_WINDOW);
				GetMousePos();
            d_x = m_x - mouse.x;
				d_y = m_y - mouse.y;
				if ((d_x > x_thresh) || (-d_x > x_thresh) ||
					 (d_y > y_thresh) || (-d_y > y_thresh))
            {
               if (!i)
               {
                  SUndo(UNDO_NONE,UNDO_CHANGE);
                  i=1;
               }
					while (d_x > x_thresh)
					{
						MoveSelVert(MOVE_LEFT,0);
						d_x -= x_thresh;
					}
					while (-d_x > x_thresh)
					{
						MoveSelVert(MOVE_RIGHT,0);
						d_x += x_thresh;
					}
					while (d_y > y_thresh)
					{
						MoveSelVert(MOVE_UP,0);
						d_y -= y_thresh;
					}
					while (-d_y > y_thresh)
					{
						MoveSelVert(MOVE_DOWN,0);
						d_y += y_thresh;
					}
					SetMousePos(m_x, m_y);
					UpdateAllViewports();
				}
			}
			status.move = FALSE;
			QUI_RedrawWindow(STATUS_WINDOW);
			/* Update all involved brush centers & normals */
         if (i)
         {
			   for (b=M.display.bsel; b; b=b->Next)
   			{
   				CalcBrushCenter(b->Brush);
   				RecalcNormals(b->Brush);
   			}

            UndoDone();

   			for (b=M.display.bsel; b; b=b->Next)
   			{
               JoinVertices(b->Brush);
/*   				CheckBrush(b->Brush, FALSE);*/
/* TODO: end of command map checker hook */
   			}
         }
   
			UpdateAllViewports();
		}
	}
}
#endif


#if TODO
void ApplyTexture(brush_t *b, char *texname)
{
	int i;

   if (b->bt->flags&BR_F_BTEXDEF)
   {
      SetTexture(&b->tex,texname);
   }
   else
   {
      for (i=0; i<b->num_planes; i++)
      {
         SetTexture(&b->plane[i].tex,texname);
      }
   }
}
#endif


void ForEachSelTexdef(void (*func)(texdef_t *p))
{
   brushref_t *b;
   fsel_t *f;
   int i;

   for (b=M.display.bsel;b;b=b->Next)
   {
      if (b->Brush->bt->flags&BR_F_BTEXDEF)
         func(&b->Brush->tex);
      else
         for (i=0;i<b->Brush->num_planes;i++)
            func(&b->Brush->plane[i].tex);
   }
   for (f=M.display.fsel;f;f=f->Next)
   {
      if (f->Brush->bt->flags&BR_F_BTEXDEF)
         func(&f->Brush->tex);
      else
         func(&f->Brush->plane[f->facenum].tex);
   }
}
#endif


#if TODO
#endif


/* TODO: these shouldn't be here */
#if TODO
/* TODO: not use bubble sort */
void BubbleSortGroups(char list[200][50], int *ref, int num)
{
	int   i;
	char  temp[256];
	int   stemp;
	int   found;


	found = TRUE;
	while (found == TRUE)
	{
		found = FALSE;
		for (i=0; i<(num-1); i++)
		{
			if (strcmp(list[i], list[i+1]) > 0)
			{
				found = TRUE;
				strcpy(temp, list[i]);
				strcpy(list[i], list[i+1]);
				strcpy(list[i+1], temp);
				stemp = ref[i];
				ref[i] = ref[i+1];
				ref[i+1] = stemp;
			}
		}
	}
}


void GetGroupName(char *name)
{
	QUI_window_t *w;

	unsigned char *temp_buf;
	char    newname[50];


	w = &Q.window[POP_WINDOW_1 + Q.num_popups];
	w->size.x = 250;
	w->size.y = 80;
	w->pos.x = (video.ScreenWidth - w->size.x) / 2;
	w->pos.y = (video.ScreenHeight - w->size.y) / 2;

	/* Actually draw the window */
	QUI_PopUpWindow(POP_WINDOW_1 + Q.num_popups, "New Group Name", &temp_buf);
	Q.num_popups++;

   QUI_Frame(w->pos.x+20,w->pos.y+40,w->pos.x+230,w->pos.y+62);

	RefreshPart(w->pos.x, w->pos.y, w->pos.x+w->size.x, w->pos.y+w->size.y);

	newname[0] = '\0';
	if (readgname(newname, w->pos.x + 25, w->pos.y + 44, w->pos.x+225, 20))
		strcpy(name, newname);
	else
		name[0] = '\0';

	/* Pop down the window */
	Q.num_popups--;
	QUI_PopDownWindow(POP_WINDOW_1 + Q.num_popups, &temp_buf);

	RefreshPart(w->pos.x, w->pos.y, w->pos.x+w->size.x, w->pos.y+w->size.y);
}


group_t *GroupPicker(void)
{
	QUI_window_t *w;

	unsigned char *temp_buf;

	group_t      *g;

	int     base_group;

	char    group_list[200][50];
	int     group_ref[200];

	int     i, j, k;

	int     b_ok,b_cancel;
	int     b_tiny_up,b_tiny_down;
   int     b;

	int     active_group = -1;


	/* Set up window Position */
	w = &Q.window[POP_WINDOW_1 + Q.num_popups];
	w->size.x = 350;
	w->size.y = 350;
	w->pos.x = (video.ScreenWidth - w->size.x) / 2;
	w->pos.y = (video.ScreenHeight - w->size.y) / 2;

	/* Set up some buttons */
   PushButtons();
	b_ok     = AddButtonText(0,0,B_ENTER,"OK");
	b_cancel = AddButtonText(0,0,B_ESCAPE,"Cancel");

	MoveButton(b_ok, w->pos.x + 120, w->pos.y + w->size.y - 30);
	MoveButton(b_cancel,button[b_ok].x+button[b_ok].sx + 5, w->pos.y + w->size.y - 30);

	/* Set up and sort group list */
	for (g=M.GroupHead, i=0; g; g=g->Next, i++)
	{
		strcpy(group_list[i], g->groupname);
		group_ref[i] = i;
	}
	BubbleSortGroups(group_list, group_ref, M.num_groups);
	base_group = 0;

	/* Set up scrolling buttons */
	b_tiny_up     = AddButtonPic(0,0,0,"button_tiny_up");
	b_tiny_down   = AddButtonPic(0,0,0,"button_tiny_down");
	MoveButton(b_tiny_up, w->pos.x + w->size.x - 30, w->pos.y + 37);
	MoveButton(b_tiny_down, w->pos.x + w->size.x - 30, w->pos.y + w->size.y - 70);

	/* Actually draw the window */
	QUI_PopUpWindow(POP_WINDOW_1 + Q.num_popups, "Select Group", &temp_buf);
	Q.num_popups++;

	/* Box Group selection area & Titles */
   QUI_Frame(w->pos.x+20,w->pos.y+35,w->pos.x+310,w->pos.y+294);

	/* Draw group list */
	for (i=base_group, j=0; (j<18) && (i<M.num_groups); i++, j++)
		QUI_DrawStr(w->pos.x + 25, w->pos.y + 37 + (j*14), BG_COLOR, (i==active_group) ? 14 : 0,0,FALSE,group_list[i]);

	/* Draw Buttons */
   DrawButtons();

	RefreshPart(w->pos.x, w->pos.y, w->pos.x+w->size.x, w->pos.y+w->size.y);

	while (1)
	{
      b=UpdateButtons();
		if (b!=-1)
		{
         if (b==b_ok)
         {
				if (active_group == -1)
				{
					HandleError("Select Group", "No group selected.");
				}
				else
            {
					break;
            }
			}

         if (b==b_cancel)
         {
				break;
			}

         if (b==b_tiny_up)
         {
            if (base_group > 0)
               base_group--;
            /* Clear text area */
            for (i=w->pos.y + 36; i<w->pos.y + 293; i++)
               DrawLine(w->pos.x + 21, i, w->pos.x + 309, i, BG_COLOR);
            /* Draw group list */
            for (i=base_group, j=0; (j<18) && (i<M.num_groups); i++, j++)
               QUI_DrawStr(w->pos.x + 25, w->pos.y + 37 + (j*14), BG_COLOR, (i==active_group) ? 14 : 0,0, FALSE, group_list[i]);
            RefreshPart(w->pos.x, w->pos.y, w->pos.x+w->size.x, w->pos.y+w->size.y);
            UpdateMouse();
            DrawMouse(mouse.x, mouse.y);
			}

         if (b==b_tiny_down)
         {
            if ((base_group+18) < M.num_groups)
            base_group++;
            /* Clear text area */
            for (i=w->pos.y + 36; i<w->pos.y + 293; i++)
               DrawLine(w->pos.x + 21, i, w->pos.x + 309, i, BG_COLOR);
            /* Draw group list */
            for (i=base_group, j=0; (j<18) && (i<M.num_groups); i++, j++)
               QUI_DrawStr(w->pos.x + 25, w->pos.y + 37 + (j*14), BG_COLOR, (i==active_group) ? 14 : 0,0, FALSE, group_list[i]);
            RefreshPart(w->pos.x, w->pos.y, w->pos.x+w->size.x, w->pos.y+w->size.y);
            UpdateMouse();
            DrawMouse(mouse.x, mouse.y);
			}
      }
      else
      if (mouse.button&1)
      {
			/* Check for click in group area */
			if (InBox(w->pos.x + 22, w->pos.y + 37, w->pos.x + 310, w->pos.y + 294))
			{
				/* Find which group they clicked on */
				for (i=base_group, j=0; (j<18) && (i<M.num_groups); i++, j++)
				{
					if (InBox(w->pos.x + 22, w->pos.y + 37 + j*14, w->pos.x + 310, w->pos.y + 51 + j*14))
						active_group = i;
				}
				/* Draw group list */
				for (i=base_group, j=0; (j<18) && (i<M.num_groups); i++, j++)
					QUI_DrawStr(w->pos.x + 25, w->pos.y + 37 + (j*14), BG_COLOR, (i==active_group) ? 14 : 0,0, FALSE, group_list[i]);
				RefreshPart(w->pos.x, w->pos.y, w->pos.x+w->size.x, w->pos.y+w->size.y);
			}

		}

		UpdateMouse();
	}

	/* Pop down the window */
	Q.num_popups--;
	QUI_PopDownWindow(POP_WINDOW_1 + Q.num_popups, &temp_buf);

	RemoveButton(b_ok);
	RemoveButton(b_cancel);
	RemoveButton(b_tiny_up);
	RemoveButton(b_tiny_down);
   PopButtons();

	RefreshPart(w->pos.x, w->pos.y, w->pos.x+w->size.x, w->pos.y+w->size.y);

   if (active_group==-1)
   {
      return NULL;
   }
   else
   {
	   for (k=0, g=M.GroupHead; (k<group_ref[active_group]) && (g); k++, g=g->Next);
	   return g;
   }
}
#endif


/* Old transform.c code basic on multiple active selections */
#if 0
#include "brush.h"
#include "entity.h"
#include "geom.h"
#include "matrix.h"
#include "memory.h"
#include "s_error.h"
#include "s_message.h"
#include "sel.h"
#include "undo.h"


/* TODO: optimize all this */


int Trans_Setup(sel_t *sel,sel_t *orig,sel_t *disp)
{
   bsel_t *bs,*bs2;
   brush_t *b,*b2;

   esel_t *es;
   entity_t *e;

   fsel_t *fs;
   face_t *f;

   vsel_t *vs;

   int i;

/*
Copy brushes, mark vertices if !sel->vsel
Copy faces, copy brush if necessary, mark vertices if !sel->vsel
If sel->vsel, copy vertices
Copy entities, copy belonging brushes, mark vertices
*/

   if (!(sel->bsel || sel->esel || sel->fsel || sel->vsel))
   {
      S_NewMessage("Nothing selected!");
      return 0;
   }

   memset(orig,0,sizeof(sel_t));
   memset(disp,0,sizeof(sel_t));

   for (bs=sel->bsel;bs;bs=bs->Next)
   {
      Sel_AddBrush(orig,bs->Brush);
      b=B_Duplicate(NULL,bs->Brush);
      if (!b)
      {
         S_Error("Trans_Setup","Out of memory!");
         return 0;
      }
      Sel_AddBrush(disp,b);
      if (!sel->vsel)
      {
         for (i=0;i<bs->Brush->num_verts;i++)
         {
            Sel_AddVert(orig,bs->Brush,i);
            Sel_AddVert(disp,b,i);
         }
      }
   }

   for (fs=sel->fsel;fs;fs=fs->Next)
   {
      for (bs=orig->bsel,bs2=disp->bsel;bs;bs=bs->Next,bs2=bs2->Next)
         if (bs->Brush==fs->Brush)
            break;
      if (bs)
      {
         b=bs->Brush;
         b2=bs2->Brush;
      }
      else
      {
         b=fs->Brush;
         Sel_AddBrush(orig,b);
         b2=B_Duplicate(NULL,b);
         if (!b2)
         {
            S_Error("Trans_Setup","Out of memory!");
            return 0;
         }
         Sel_AddBrush(disp,b2);
      }
      if (!sel->vsel)
      {
         f=&fs->Brush->faces[fs->num];
         for (i=0;i<f->num_verts;i++)
         {
            Sel_AddVert(orig,b,f->verts[i]);
            Sel_AddVert(disp,b2,f->verts[i]);
         }
      }
   }

   if (sel->vsel)
   {
      QASSERT(1);
   }

/*   for (es=sel->esel;es;es=es->Next)
   {
      Sel_AddEnt(orig,es->Entity);
      e=E_Duplicate(NULL,es->Entity);
      if (!e)
      {
         S_Error("Trans_Setup","Out of memory!");
         return 0;
      }
   }*/

   return 1;
}

void Trans_Done(sel_t *orig,sel_t *disp)
{
   bsel_t *bs,*bs2;
   vsel_t *vs,*vs2;
   esel_t *es,*es2;
   fsel_t *fs,*fs2;

   for (vs=orig->vsel;vs;vs=vs2)
   {
      vs2=vs->Next;
      Q_free(vs);
   }
   for (fs=orig->fsel;fs;fs=fs2)
   {
      fs2=fs->Next;
      Q_free(fs);
   }
   for (bs=orig->bsel;bs;bs=bs2)
   {
      bs2=bs->Next;
      Q_free(bs);
   }
   for (es=orig->esel;es;es=es2)
   {
      es2=es->Next;
      Q_free(es);
   }
   
   for (vs=disp->vsel;vs;vs=vs2)
   {
      vs2=vs->Next;
      Q_free(vs);
   }
   for (fs=orig->fsel;fs;fs=fs2)
   {
      fs2=fs->Next;
      Q_free(fs);
   }
   for (bs=disp->bsel;bs;bs=bs2)
   {
      bs2=bs->Next;
      B_Free(bs->Brush);
      Q_free(bs);
   }
   for (es=orig->esel;es;es=es2)
   {
      es2=es->Next;
      E_Free(es->Entity);
      Q_free(es);
   }

   memset(orig,0,sizeof(sel_t));
   memset(disp,0,sizeof(sel_t));
}

void Trans_Linear(matrix_t m,sel_t *orig,sel_t *disp)
{
   vsel_t *vs1,*vs2;
   vec3_t *v1,*v2;

   bsel_t *bs;
   esel_t *es;

   for (bs=disp->bsel;bs;bs=bs->Next)
      U_BrushModify(bs->Brush);
   for (es=disp->esel;es;es=es->Next)
      U_EntityModify(es->Entity);

   for (vs1=orig->vsel,vs2=disp->vsel;vs1;vs1=vs1->Next,vs2=vs2->Next)
   {
      v1=&vs1->Brush->verts[vs1->num];
      v2=&vs2->Brush->verts[vs1->num];

      v2->x=
         m[0][0]*v1->x+
         m[0][1]*v1->y+
         m[0][2]*v1->z+
         m[0][3];
      v2->y=
         m[1][0]*v1->x+
         m[1][1]*v1->y+
         m[1][2]*v1->z+
         m[1][3];
      v2->z=
         m[2][0]*v1->x+
         m[2][1]*v1->y+
         m[2][2]*v1->z+
         m[2][3];
   }
}


void Trans_Center(sel_t *orig,vec3_t *center)
{
   vsel_t *vs;
   vec3_t min,max;

   vs=orig->vsel;
   if (!vs)
   {
      center->x=center->y=center->z=0;
      return;
   }
   min=max=vs->Brush->verts[vs->num];

   for (vs=vs->Next;vs;vs=vs->Next)
   {
      VEC_CheckMin(min,vs->Brush->verts[vs->num]);
      VEC_CheckMax(max,vs->Brush->verts[vs->num]);
   }
   center->x=(min.x+max.x)/2;
   center->y=(min.y+max.y)/2;
   center->z=(min.z+max.z)/2;
}


void TransformLinear(matrix_t m,sel_t *s)
{
   sel_t orig,disp;
   
   if (!Trans_Setup(s,&orig,&disp))
      return;
   /* reverse order since we want to modify the original */
   Trans_Linear(m,&disp,&orig);
   Trans_Done(&orig,&disp);
}
#endif


/*
Group system description

group (next,last, parent,child,cnext,clast)

World             (null    ,Foo    ,null     ,null        )
  Foo             (World   ,Foobar ,Bar      ,null        )
    Foobar        (Foo     ,null   ,Foozot   ,null        )
    Foozot        (Foo     ,null   ,null     ,Foobar      )
  Bar             (World   ,Barzot ,Zot      ,Foo         )
    Barzot        (Bar     ,null   ,Barbaz   ,null        )
    Barbaz        (Bar     ,null   ,null     ,Barzot      )
  Zot             (World   ,Quux   ,null     ,Bar         )
    Quux          (Zot     ,Foobaz ,Zotbar   ,null        )
      Foobaz      (Quux    ,null   ,Bazzot   ,null        )
      Bazzot      (Quux    ,null   ,null     ,Bazzot      )
    Zotbar        (Zot     ,null   ,null     ,Quux        )

insert in parent:
  cnext=parent.child
  clast=null
  parent.child.clast=self
  parent.child=self

delete, move children to parent:
  if (child!=null)
  {
     for (each child) child.parent=parent
     child.clast=clast
     last_child.cnext=cnext
     clast.cnext=child
     cnext.clast=last_child
  }
  else
  {
    if (cnext) cnext.clast=clast
    if (clast) clast.cnext=cnext else parent.child=cnext
  }

delete, keep children:
    if (cnext) cnext.clast=clast
    if (clast) clast.cnext=cnext else parent.child=cnext

*/

/*
Undo system description

State:
   normal      Save everything in current undo. If !CurUndo, create one. Default state.
   noundo      If we get any U_* calls, abort.
   undo_clear  Ignore all U_* calls, CurUndo=NULL, all undo information cleared.

              normal                                   noundo                                   undo_clear
Undo_Done     Wrap up CurUndo, CurUndo=NULL.           state=normal                             Make sure everything is
              state=normal                                                                      cleared. state=normal
Undo_Update   like current                             do nothing                               Map_Update
Undo_New      check CurUndo=NULL, ignore otherwise     invalid                                  ignore
Undo_NewClear free all undo information,               free all undo, state=undo_clear          ignore
              state=undo_clear

(CurUndo!=NULL)
to normal     x                                        Undo_New flag                            Undo_New flag or Undo_SetClear
to noundo     when done                                x                                        Undo_SetClear
to undo_clear when done                                can't                                    x

*/

