/*
popupwin.c file of the Quest Source Code

Copyright 1997, 1998 Alexander Malmberg
Copyright 1996, Trey Harrison and Chris Carollo

This program is distributed under the GNU General Public License.
See legal.txt for more information.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#ifdef DJGPP
#include <dos.h>
#include <dir.h>
#endif


#include "defines.h"
#include "types.h"

#include "popupwin.h"

#include "button.h"
#include "error.h"
#include "file.h"
#include "keyboard.h"
#include "mdl.h"
#include "memory.h"
#include "mouse.h"
#include "qui.h"
#include "video.h"


#if 0
void AutoBuildPopup(void)
{
	QUI_window_t *w;
	unsigned char *temp_buf;

	int op1, op2, op3, op4, op5, op6;
	int cancel;
   int bp;

	int i;
	char go_string[256];
	char temp_str[256];
	int just_visible;

   if (M.modified)
   {
      if (QUI_YesNo(
             "Modified map",
             "The map has been modified since the last save. Save now?",
             "Save",
             "No"))
      {
         SaveMap(M.mapfilename);
      }
   }

	/* Set up window Position */
	w = &Q.window[POP_WINDOW_1 + Q.num_popups];
	w->size.x = 300;
	w->size.y = 220;
	w->pos.x = (video.ScreenWidth - w->size.x) / 2;
	w->pos.y = (video.ScreenHeight - w->size.y) / 2;

	/* Make the option buttons */
   PushButtons();
	op1 = AddButtonText(0,0,0," ");
	op2 = AddButtonText(0,0,0," ");
	op3 = AddButtonText(0,0,0," ");
	op4 = AddButtonText(0,0,0," ");
	op5 = AddButtonText(0,0,0," ");
	op6 = AddButtonText(0,0,0," ");

	cancel = AddButtonText(0,0,0,"Cancel");

	MoveButton(op1, w->pos.x + 20, w->pos.y + 35);
	MoveButton(op2, w->pos.x + 20, w->pos.y + 57);
	MoveButton(op3, w->pos.x + 20, w->pos.y + 79);
	MoveButton(op4, w->pos.x + 20, w->pos.y + 101);
	MoveButton(op5, w->pos.x + 20, w->pos.y + 123);
	MoveButton(op6, w->pos.x + 20, w->pos.y + 145);

	MoveButton(cancel,w->pos.x+w->size.x/2-button[cancel].sx/2,w->pos.y+w->size.y-30);

	/* Actually draw the window */
	QUI_PopUpWindow(POP_WINDOW_1 + Q.num_popups, "Select Build", &temp_buf);
	Q.num_popups++;

	/* Draw the buttons */
   DrawButtons();

	QUI_DrawStr(w->pos.x + 45, w->pos.y +  40, BG_COLOR, 0,0, FALSE,"Fast (no error checking)");
	QUI_DrawStr(w->pos.x + 45, w->pos.y +  62, BG_COLOR, 0,0, FALSE,"Fast (with error checking)");
	QUI_DrawStr(w->pos.x + 45, w->pos.y +  84, BG_COLOR, 0,0, FALSE,"Entities Only");
	QUI_DrawStr(w->pos.x + 45, w->pos.y + 106, BG_COLOR, 0,0, FALSE,"Lighting Only");
	QUI_DrawStr(w->pos.x + 45, w->pos.y + 128, BG_COLOR, 0,0, FALSE,"Full Build");
	QUI_DrawStr(w->pos.x + 45, w->pos.y + 150, BG_COLOR, 0,0, FALSE,"Build Visible");

	RefreshPart(w->pos.x, w->pos.y, w->pos.x+w->size.x, w->pos.y+w->size.y);

   just_visible=FALSE;
	while (1)
	{
      UpdateMouse();
      bp=UpdateButtons();

      if (bp==op1)
      {
         strcpy(go_string, "go1");
         just_visible = FALSE;
         break;
      }

      if (bp==op2)
      {
         strcpy(go_string, "go2");
         just_visible = FALSE;
         break;
      }

      if (bp==op3)
      {
         strcpy(go_string, "go3");
         just_visible = FALSE;
         break;
      }

      if (bp==op4)
      {
         strcpy(go_string, "go4");
         just_visible = FALSE;
         break;
      }

      if (bp==op5)
      {
         strcpy(go_string, "go5");
         just_visible = FALSE;
         break;
      }

      if (bp==op6)
      {
         strcpy(go_string, "go1");
         just_visible = TRUE;
         break;
      }

      if (bp==cancel)
      {
         go_string[0]=0;
         break;
      }
	}

	/* Pop down the window */
	Q.num_popups--;
	QUI_PopDownWindow(POP_WINDOW_1 + Q.num_popups, &temp_buf);

	RemoveButton(op1);
	RemoveButton(op2);
	RemoveButton(op3);
	RemoveButton(op4);
	RemoveButton(op5);
	RemoveButton(op6);
	RemoveButton(cancel);
   PopButtons();

	RefreshPart(w->pos.x, w->pos.y, w->pos.x+w->size.x, w->pos.y+w->size.y);

	if (strlen(go_string) > 0)
   {
		SetMode(RES_TEXT);

		if (just_visible)
      {
			CreateVisibleMap("questtmp.map");
      	KBD_RemoveHandler();
			system("go1 questtmp");
	      KBD_InstallHandler();
			remove("questtmp.map");
		}
		else
      {
			sprintf(temp_str, "%s %s", go_string, M.mapfilename);
			for (i=0; i<strlen(temp_str); i++)
         {
				if (temp_str[i] == '.')
					temp_str[i] ='\0';
			}
      	KBD_RemoveHandler();
			system(temp_str);
	      KBD_InstallHandler();
		}

		SetMode(options.vid_mode);

		InitMouse();
		SetPal(PAL_CURRENT);
		QUI_RedrawWindow(MESG_WINDOW);
		QUI_RedrawWindow(TOOL_WINDOW);
		QUI_RedrawWindow(STATUS_WINDOW);
		UpdateAllViewports();
	}
}
#endif

