#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "defines.h"
#include "types.h"

#include "cmds.h"

#include "brush.h"
#include "quest.h"
#include "s_gui.h"
#include "s_message.h"
#include "uid.h"
#include "undo.h"


static void C_group_edit(void)
{
   S_GUI_GroupEditor();
}


static void C_add_to(void)
{
   bsel_t *bs;
   esel_t *es;

   if (!M.sel.bsel && !M.sel.esel)
   {
      S_NewMessage("group.add_to: Nothing selected!");
      return;
   }

   if (!UID_Group(M.CurGroup))
   {
      S_NewMessage("group.add_to: Current group is invalid!");
      return;
   }

   for (bs=M.sel.bsel;bs;bs=bs->Next)
   {
      U_BrushModify(bs->Brush);
      bs->Brush->Group=M.CurGroup;
   }

   for (es=M.sel.esel;es;es=es->Next)
   {
      U_EntityModify(es->Entity);
      es->Entity->Group=M.CurGroup;
   }
   Cmd_SetRedraw(2);
}

static cmd_reg_t cmds[]={
{"group.edit",C_group_edit,{"Edit/Groups...","alt+g"},{},"Brings up the group editor."},
{"group.add_to",C_add_to,{NULL,"alt+shift+g"},{},"Moves the selection to the current group."},
};

#include "plugin.h"
PLUGIN_HEAD

static plugin_t plugin=
{{Init},{"basic/groups","The group editor"}};

PLUGIN_FOOT_CMDS

