#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <unistd.h>

#include "hook.h"
#include "s_error.h"

static void rcs_backup(const char *name)
{
   int i;
   i=fork();
   if (i==-1)
   {
      S_Error("RCS backup","Couldn't backup (fork failed!");
      return;
   }
   if (i) return;
   execlp("ci","ci","-q","-l","-m.",name,NULL);
   fprintf(stderr,"exec failed!\n");
   abort();
}

#include "plugin.h"

PLUGIN_HEAD

static plugin_t plugin=
{{Init},{"basic/rcs_backup","Backup .map files using rcs."}};

static int Init(void)
{
   Hook_AddFunc(hk_map_saved,HOOK_FUNC_VOID,(hook_func_void_t)rcs_backup,NULL,&plugin);
   return 1;
}

PLUGIN_FOOT

