#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "defines.h"
#include "types.h"

#include "cmds.h"

#include "config.h"
#include "edsel.h"
#include "quest.h"
#include "s_menu.h"
#include "s_message.h"
#include "status.h"


/* TODO: add support for toggleable menu-items so the user can see
the current settings in the menu. */
static void UpdateRFlags(int change,int add,int del)
{
   int oldf;
   int rem;
   
   oldf=cv_render_flags->i;
   if (!(cv_render_flags->i&change))
   {
      Cfg_SetInt(cv_render_flags,cv_render_flags->i|change|add);
   }
   else
   {
      rem=change|del;
      Cfg_SetInt(cv_render_flags,cv_render_flags->i&(~rem));
      rem&=oldf;
      if (rem&RENDER_ENTITY_FOCAL) ClearSelEnts();
      if (rem&RENDER_FACE_VERT)
      {
         ClearSelVerts();
         ClearSelFaces();
      }
      if (rem&RENDER_BRUSH_VERT)
      {
         ClearSelVerts();
         ClearSelBrushes();
      }
   }
   Cmd_SetRedraw(2);
}

static void C_brush(void)
{
   UpdateRFlags(RENDER_BRUSH,0,RENDER_BRUSH_FOCAL|RENDER_BRUSH_VERT);
}

static void C_brush_focal(void)
{
   UpdateRFlags(RENDER_BRUSH_FOCAL,RENDER_BRUSH,RENDER_BRUSH_VERT);
}

static void C_brush_vert(void)
{
   UpdateRFlags(RENDER_BRUSH_VERT,RENDER_BRUSH|RENDER_BRUSH_FOCAL,0);
}

static void C_face_focal(void)
{
   UpdateRFlags(RENDER_FACE_FOCAL,RENDER_BRUSH,RENDER_FACE_VERT);
}

static void C_face_vert(void)
{
   UpdateRFlags(RENDER_FACE_VERT,RENDER_BRUSH|RENDER_FACE_FOCAL,0);
}

static void C_entity(void)
{
   UpdateRFlags(RENDER_ENTITY,0,RENDER_ENTITY_FOCAL|RENDER_ENTITY_LINK);
}

static void C_entity_focal(void)
{
   UpdateRFlags(RENDER_ENTITY_FOCAL,RENDER_ENTITY,RENDER_ENTITY_LINK);
}

static void C_entity_link(void)
{
   UpdateRFlags(RENDER_ENTITY_LINK,RENDER_ENTITY|RENDER_ENTITY_FOCAL,0);
}


/* TODO */
static cmd_reg_t cmds[]={
{"render.toggle_brush"          ,C_brush          ,{"View/Display/Brushes"            },{},""},
{"render.toggle_brush_focal"    ,C_brush_focal    ,{"View/Display/Brush focal-points" },{},""},
{"render.toggle_brush_vert"     ,C_brush_vert     ,{"View/Display/Brush vertices"     },{},""},
{"render.toggle_face_focal"     ,C_face_focal     ,{"View/Display/Face focal-points"  },{},""},
{"render.toggle_face_vert"      ,C_face_vert      ,{"View/Display/Face vertices"      },{},""},
{"render.toggle_entity"         ,C_entity         ,{"View/Display/Entities"           },{},""},
{"render.toggle_entity_focal"   ,C_entity_focal   ,{"View/Display/Entity focal-points"},{},""},
{"render.toggle_entity_link"    ,C_entity_link    ,{"View/Display/Entity links"       },{},""},
};

#include "plugin.h"
PLUGIN_HEAD

static plugin_t plugin=
{{Init},{"basic/rflags","Commands to change the rendering flags."}};

static int Init(void)
{
   Cmd_Register(&plugin,cmds,sizeof(cmds));
   UpdateRFlags(0,0,0);
   return 1;
}

PLUGIN_FOOT

