#ifndef CONFIG_H
#define CONFIG_H

typedef struct config_var_s
{
   char *name;
   char *desc;
   char *def;

   char *s;
   int i;
   float f;
} config_var_t;


extern config_var_t **cvars;
extern int num_cvars;


/* Define the variable, give it the value 'value' if it doesn't already exist. */
config_var_t *Cfg_DefVar(const char *name,const char *value,const char *desc);

int Cfg_Int(const char *name);
float Cfg_Float(const char *name);
const char *Cfg_Str(const char *name);

void Cfg_SetInt(config_var_t *c,int i);
void Cfg_SetFloat(config_var_t *c,float f);
void Cfg_SetStr(config_var_t *c,const char *str);


void Config_Load(const char *fname);
void Config_Save(const char *fname);

#endif

