#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include <gtk/gtk.h>

#include "s_main.h"

#include "config.h"
#include "gl/g_3d.h"
#include "gl/g_texpick.h"
#include "g_input.h"
#include "g_menu.h"
#include "g_message.h"
#include "g_signals.h"
#include "g_toolbar.h"
#include "s_quest.h"
#include "version.h"


void S_Exit(void)
{
   gtk_main_quit();
}

void S_SetMapName(const char *name)
{
   char buf[256];

   snprintf(buf,sizeof(buf)-1,"Quest - %s",name?name:"untitled");
   gtk_window_set_title(S_menu_window,buf);
}


int main(int argc, char **argv)
{
   InitQuestCore();
/* TODO: Load and save
global file  $(prefix)/share/quest/quest.cfg
user file    ~/.quest.cfg
local file   ./quest.cfg
*/
#ifndef ALPHA /* disable while testing so I can change defaults easier */
#define QUEST_INSTALL_PREFIX "/usr/local/"
   Config_Load(QUEST_INSTALL_PREFIX "share/quest.cfg");
   Config_Load("~/.quest.cfg");
   Config_Load("./quest.cfg");
#endif

   gtk_init(&argc,&argv);


   S_InitSignals();
   S_InitInput();
   S_InitMenu(); /* need this first since all other windows are transient with regard to this  TODO? */
   S_InitMessages();
   S_InitToolbar();
   S_InitViewports();
   S_InitTexturePicker();

   S_NewMessage("Quest-GTK initialized (%s).",QUEST_VERSION);

   InitQuest(argc,argv);
   gtk_main();
   DoneQuest();

   S_DoneViewports();
   S_DoneToolbar();
   S_DoneMessages();
   S_DoneMenu();
   S_DoneInput();

   Config_Save("quest.cfg");
   
   return 0;
}

