#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "../glade_support.h"


#include "cmds.h"
#include "plugin.h"


static GtkCList *cl;

gboolean pm_delete(void)
{
   gtk_main_quit();
   return TRUE;
}

void pm_done(void)
{
   gtk_main_quit();
}

void pm_activate(void)
{
   int r;
   plugin_t *p;
   
   if (!cl->selection) return;
   r=GPOINTER_TO_INT(cl->selection->data);

   p=gtk_clist_get_row_data(cl,r);
   if (p->active) return;
   Plugin_Activate(p);
   gtk_clist_set_text(cl,r,0,p->active?"Y":"N");
}

void pm_deactivate(void)
{
   int r;
   plugin_t *p;
   
   if (!cl->selection) return;
   r=GPOINTER_TO_INT(cl->selection->data);

   p=gtk_clist_get_row_data(cl,r);
   if (!p->active) return;
   Plugin_Deactivate(p);
   gtk_clist_set_text(cl,r,0,p->active?"Y":"N");
}


static void C_plugin_edit(void)
{
   GtkWidget *pm;

   pm=create_pm();
   gtk_box_set_homogeneous(GTK_BOX(lookup_widget(pm,"dialog_action_area1")),0);

   {
      int i,r;
      char *str[3];
      plugin_t *p;
      
      cl=GTK_CLIST(lookup_widget(pm,"plugins"));
      gtk_clist_clear(cl);
      for (i=0;i<num_plugins;i++)
      {
         p=plugins[i];
         str[0]=p->active?"Y":"N";
         str[1]=p->s.name;
         str[2]=p->s.desc;

         r=gtk_clist_append(cl,str);
         gtk_clist_set_row_data(cl,r,p);
      }
   }
   gtk_clist_columns_autosize(cl);

   gtk_widget_show(pm);
   gtk_main();
   gtk_widget_destroy(pm);
}

static cmd_reg_t cmds[]={
{"plugin.edit",C_plugin_edit,{"File/Plugins..."},{},"Activate/deactivate plugins."},
};

PLUGIN_HEAD

static plugin_t plugin=
{{Init},{"basic/gtk/plugins","Plugin-managing dialog."}};

PLUGIN_FOOT_CMDS

