#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include <gdk/gdk.h>
#include <gtk/gtk.h>

#undef TRUE
#undef FALSE
#include "defines.h"
#include "types.h"

#include "s_int.h"

#include "gl/g_3d_all.h"
#include "g_input.h"


static int selection_window_event(GtkWidget *w,GdkEventButton *e,gpointer data)
{
   gtk_main_quit();
   return 1;
}


static int cur_sx,cur_sy,cur_ex,cur_ey;

void S_SelectionWindow_DrawBox(int x0,int y0,int x1,int y1);

static void UndrawBox(void)
{
   if (S_cur_gvport->pic)
   {
      int sx,sy,w,h;

      if (cur_sx<cur_ex)
         sx=cur_sx,w=cur_ex-sx+1;
      else
         sx=cur_ex,w=cur_sx-sx+1;
         
      if (cur_sy<cur_ey)
         sy=cur_sy,h=cur_ey-sy+1;
      else
         sy=cur_ey,h=cur_sy-sy+1;

      /* TODO: might be more efficient to split into four small rectangles */
      gdk_draw_pixmap(
         GTK_WIDGET(S_cur_gvport->da)->window,
         GTK_WIDGET(S_cur_gvport->da)->style->fg_gc[GTK_WIDGET_STATE(GTK_WIDGET(S_cur_gvport->da))],
         S_cur_gvport->pic,
         sx,sy,
         sx,sy,
         w,h);
   }
}

static int selection_window_mevent(GtkWidget *w,GdkEventMotion *e,gpointer data)
{
   int x,y;
   GdkModifierType s;
   
   if (e->is_hint)
   {
      gdk_window_get_pointer(e->window,&x,&y,&s);
   }
   else
   {
      x=e->x;
      y=e->y;
   }

   if (x!=cur_ex || y!=cur_ey)
   {
      UndrawBox();
      cur_ex=x;
      cur_ey=y;
      S_SelectionWindow_DrawBox(cur_sx,cur_sy,cur_ex,cur_ey);
   }

   return 1;
}

int S_I_SelectionWindow(vec3_t *min,vec3_t *max)
{
   int x,y;

   S_process_key=S_process_mouse=0;

   gtk_signal_connect(GTK_OBJECT(S_cur_gvport->win),"button_press_event",GTK_SIGNAL_FUNC(selection_window_event),NULL);
   gtk_signal_connect(GTK_OBJECT(S_cur_gvport->win),"button_release_event",GTK_SIGNAL_FUNC(selection_window_event),NULL);
   gtk_signal_connect(GTK_OBJECT(S_cur_gvport->win),"motion_notify_event",GTK_SIGNAL_FUNC(selection_window_mevent),NULL);
   
   gdk_pointer_grab(GTK_WIDGET(S_cur_gvport->win)->window,TRUE,
      GDK_BUTTON_RELEASE_MASK|GDK_BUTTON_PRESS_MASK|
      GDK_POINTER_MOTION_MASK|GDK_POINTER_MOTION_HINT_MASK,
      GTK_WIDGET(S_cur_gvport->win)->window,NULL,0);

   gdk_window_get_pointer(GTK_WIDGET(S_cur_gvport->win)->window,&x,&y,NULL);
   min->x=x;
   min->y=y;
   min->z=0;

   cur_sx=cur_ex=x;
   cur_sy=cur_ey=y;
   gtk_main();
   UndrawBox();

   gdk_window_get_pointer(GTK_WIDGET(S_cur_gvport->win)->window,&x,&y,NULL);
   max->x=x;
   max->y=y;
   max->z=0;
   
   gdk_pointer_ungrab(0);
   
   gtk_signal_disconnect_by_func(GTK_OBJECT(S_cur_gvport->win),GTK_SIGNAL_FUNC(selection_window_event),NULL);

   S_process_key=S_process_mouse=1;

   if (min->x>max->x)
   {
      double t;
      t=min->x;
      min->x=max->x;
      max->x=t;
   }
   if (min->y>max->y)
   {
      double t;
      t=min->y;
      min->y=max->y;
      max->y=t;
   }

   return 1;
}

