#ifndef TRACE_H
#define TRACE_H

/*
Trace from org along dir (assumed to be normalized) for len units. Calls func
for all objects the ray hits, in no particular order (you'll have to sort
by distance yourself).

flags controls what is traced against:
   TRACE_ENTITY
      Check for entities. Call func(dist,TRACE_ENTITY,ent,-1) for each.
   TRACE_FACE
      Check for faces and curves. Call func(dist,TRACE_FACE,brush,face_num)
      for each normal face and func(dist,TRACE_FACE,brush,-1) for curves.
*/
void Trace(vec3_t org,vec3_t dir,scalar_t len,int flags,
   void (*func)(scalar_t dist,int type,void *v,int face));

#define TRACE_ENTITY  1
#define TRACE_FACE    2
   
#endif

