
CFLAGS = -g -O2 -Wall -W \
	-Wbad-function-cast -Wcast-align -Wcast-qual -Wchar-subscripts -Wcomment -Wformat -Wimplicit  \
	-Wmissing-prototypes -Wnested-externs -Wparentheses -Wpointer-arith -Wreturn-type -Wswitch \
	-Wuninitialized -Wunused -Wwrite-strings


# Used to compile normal stuff
COMPILE_1 = @echo $(CC) -c $< -o $@
COMPILE_2 = @$(CC) -Wp,-MMD,$(dir $<).deps/$(basename $(notdir $<)).dd COMPILE_CFLAGS -c $< -o $@
COMPILE_3 = @sed -e "s+^[^:]*:+$@:+" $(dir $<).deps/$(basename $(notdir $<)).dd > $(dir $<).deps/$(basename $(notdir $<)).d && rm -f $(dir $<).deps/$(basename $(notdir $<)).dd



# Used to compile code that might end up in shared libraries (quest/, cmd/)
Q_O_SUFFIX = .o
Q_CC = gcc

Q_COMPILE_1 = @echo $(Q_CC) -c $< -o $@
Q_COMPILE_2 = @$(Q_CC) $(Q_CFLAGS) -Wp,-MMD,$(dir $<).deps/$(basename $(notdir $<)).dd COMPILE_CFLAGS -c $< -o $@
Q_COMPILE_3 = @sed -e "s+^[^:]*:+$@:+" $(dir $<).deps/$(basename $(notdir $<)).dd > $(dir $<).deps/$(basename $(notdir $<)).d && rm -f $(dir $<).deps/$(basename $(notdir $<)).dd


# To build shared libraries
Q_LIB_SUFFIX = .so
Q_MAKELIB = gcc -g -shared -Wl,-soname -Wl,$@ -o $@ $^
Q_CFLAGS = -fPIC -DPIC

# To build static libraries
#Q_LIB_SUFFIX = .a
#Q_MAKELIB = ar rcs $?
#Q_CFLAGS =

