#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "defines.h"
#include "types.h"

#include "qfunc.h"

#include "config.h"
#include "quest.h"
#include "status.h"
#include "texdef.h"

#include "fe/message.h"
#include "fe/texpick.h"


static void C_edit_texture_pick(void)
{
   char buf[MAX_TEXTURE_NAME];
   
   if (!S_TexturePicker(buf,cv_texture_current->s))
      return;

   Cfg_SetStr(cv_texture_current,buf);

   if (M.sel.bsel || M.sel.fsel)
   {
      SetTextureSel(&M.sel,buf);
      S_NewMessage("Applied texture '%s' to selection.",buf);
   }
   else
   {
      S_NewMessage("Current texture set to '%s'.",buf);
   }
}
static func_t F_edit_texture_pick=
{"edit.texture.pick",FUNC_VOID,{fv:C_edit_texture_pick},NULL,NULL,0,
{"Brings up the texture picker and applies the texture to the selection."}};


static void C_edit_texture_apply(void)
{
   if (M.sel.bsel || M.sel.fsel)
   {
      SetTextureSel(&M.sel,cv_texture_current->s);
      S_NewMessage("Applied texture '%s' to selection.",cv_texture_current->s);
   }
   else
      S_NewMessage("texture.apply: Nothing selected!");
}
static func_t F_edit_texture_apply=
{"edit.texture.apply",FUNC_VOID,{fv:C_edit_texture_apply},NULL,NULL,0,
{"Applies the current texture to the selection."}};


static func_t *funcs[]={&F_edit_texture_pick,&F_edit_texture_apply};


#include "plugin.h"
PLUGIN_HEAD

static plugin_t plugin=
{{Init},{"edit.texture.set","Commands to texture objects."}};

PLUGIN_FOOT_FUNCS

