#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include "quest/fe/error.h"

#ifdef OLD_STUFF
void S_Error(const char *proc, const char *format, ...)
{
	va_list args;
	fprintf(stderr,"Error! %s: ",proc);
	va_start(args,format);
	vfprintf(stderr,format,args);
	va_end(args);
	fprintf(stderr,"\n\n");
}

/* Like S_Error, but will terminate the program after attempting to
save the current map to 'q_backup.map'.
*/
void S_Abort(const char *proc,const char *format, ...)
{
	va_list args;
	fprintf(stderr,"Abort! %s: ",proc);
	va_start(args,format);
	vfprintf(stderr,format,args);
	va_end(args);
	fprintf(stderr,"\n\n");
//	abort();
	exit(1);
}
#endif

#include <signal.h>

void FE_Abort(const char *type,const char *format, ...)
{
	va_list args;

	fprintf(stderr,"\n*** %s ***\n",type);
	va_start(args,format);
	vfprintf(stderr,format,args);
	fprintf(stderr,"Quest aborted.\n\n");
	signal(SIGABRT,SIG_DFL);
	abort();
}

void FE_Error(const char *str)
{
	fprintf(stderr,"\n** Error **\n%s\n\n",str);
}

