#include <math.h>

#include "defines.h"
#include "types.h"

#include "clip.h"

#include "geom.h"


int SplitLine(vec3_t v1,vec3_t v2,vec3_t *s,plane_t *p)
{
   double d1,d2,d;

   d1=DotProd(v1,p->n)-p->dist;
   d2=DotProd(v2,p->n)-p->dist;

   if (fabs(d1)<0.01 && fabs(d2)<0.01) return 0;
   if (d1> 0.01 && d2> 0.01) return -1;
   if (d1<-0.01 && d2<-0.01) return -2;

   d=d1/(d1-d2);
   s->x=v1.x+(v2.x-v1.x)*d;
   s->y=v1.y+(v2.y-v1.y)*d;
   s->z=v1.z+(v2.z-v1.z)*d;
   if (d1<0) return -4;
   return -3;
}


int ClipLine(vec3_t *v1,vec3_t *v2,plane_t *p)
{
   vec3_t v;

   switch (SplitLine(*v1,*v2,&v,p))
   {
   default: /* shouldn't be here */
   case 0:
   case -1: return -1;
   
   case -2: return 0;

   case -3:
      *v2=v;
      return -2;
      
   case -4:
      *v1=v;
      return -3;
   }
}

