#ifndef CMDS_H
#define CMDS_H

/* TODO */

#error don't include this file, it doesn't do anything (currently)


#ifdef OLD_STUFF
typedef struct cmd_reg_s
{
	const	char *name;
	void (*func)(void);
   struct
   { /* Default menu position and bound key, NULL if none.
     Menu should be like "menu/sub-menu/sub-menu/name", e.g.
     "File/Exit" or "Brush/Create/Prism...". */
      const char *menu;
      const char *key;
   } d;

   struct
   {
      int flags;
#define CMD_NOUNDO      0x01  /* This command doesn't change anything */
#define CMD_UNDO_CLEAR  0x02
#define CMD_MOVE        0x04
#define CMD_REENTRANT   0x08
/*
Flags for this command, a string that tells the command system
if the command is special in any way, or NULL if there are no
flags.

TODO: have a int flags; field for now, think about how to handle
all this.
Generic flags:
  'u'   Undo information shouldn't be saved for this command
        (which means the command must call Undo_Clear somewhere,
        or not change anything). No other flag should be set.
        Examples: undo, map_new, map_load. Could also be used for stuff
        like camera_move_left, but that isn't required.

  'm'   The command is a movement/viewport command. It only changes viewport
        settings (but not anything that changes the viewports capabilities)/
        camera positions/etc. It does not change any map data, and
        it doesn't change the selection. Used for commands that are supposed to
        be called inside other commands, e.g. brush_create_click_draw. Commands
        with this flag automatically get flag 'r'.
        Examples: camera_move_left
        TODO: sometimes (e.g. brush_create_click_draw) we want only movement,
        not rotating or switching 2d<->3d, how do we handle that? Are there any
        commands the accept rotation but not selection? If not, 'm' could be
        movement only, and 'r' covers all other reentrant commands.
        Answer: Yes, three point clipping plane doesn't want selection, but
        rotating, and even switching viewport, may be useful.
        
  'r'   Command is reentrant, i.e. it can be called while another comamnd
        is in progress. Only commands with this flag can be used while
        inside another command. Commands marked with this should not call
        other commands (even indirectly), or at least be _very_ careful with
        it (hooks on commands might change it from what you think it is).
        Examples: edit_select_control, edit_select_all_vertices


TODO: Implement this?
Should we use this system, or have a function call based system instead
so commands that need multiple selections call a S_R_Interactive() command.
Only parse the first parameter this way?

Parameters consist of a ':' followed by flags, eventually followed by another
':', and so forth. The flags are:
  'm's''   Create a new 'current' selection using the message 's'. This will bring
           up a box (or something) with the message and then let the user move around
           and select stuff (commands flagged with 'm' and 'r' above).

  'v'      The list of currently selected vertices.
  'f'      The list of currently selected faces.
  't'      The list of currently selected texdef:s.
  'b'      The list of currently selected brushes.
  'e'      The list of currently selected entities.


Examples:

C_csg_subtract((brushes_t subtract_from,brushes_t subtract_with));
":b:m'Select the subtractor(s).'b:"

C_brush_snap_to_vert((vertices_t move_these,vertices_t handle,vertices_t dest));
":v:m'Select the handle vertex.'v:m'Select the destination vertex.'v:"

C_face_split_edge_and_face((faces_t f,vertices_t edge1,vertices_t edge2));
":f:v:m'Select the other edge.'v:"
  
*/

      const char *undo_name;
      /* Name given to the undo system. Commands with the same undo_name will
      have their undo information combined. */
   } f;
   const char *desc;
   const char *help_text; /* long description */

   /* Internal */
   struct hook_s *hook;
} cmd_reg_t;


cmd_reg_t *Cmd_Lookup(const char	*name);
void Cmd_Run(const char	*name);

void Cmd_Push(int filter);
void Cmd_Pop(void);

struct plugin_s;
void Cmd_Register(struct plugin_s *p,cmd_reg_t *cmd,int size);


/* TODO: move to some other file? */
void Cmd_SetRedraw(int i);
void Cmd_HandleRedraw(void);

/* Aborts the current command, tries to recover by restoring map data using
undo information and longjmp:ing back to the main loop. Use instead of S_Abort in
commands.
TODO: Worry about memory leaks when doing this? Probably can't do anything about it,
and leaking some memory is better than crashing. */
void Cmd_Abort(const char *proc,const char *format, ...) __attribute__ ((noreturn,format(printf,2,3)));
#endif

#endif

