/* TODO: this should be cvar.[ch]; cfg.[ch] should deal with configurations */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "defines.h"
#include "types.h"

#include "config.h"

#include "qatom.h"
#include "qsymbol.h"



config_var_t *Cfg_DefVar(struct config_s *cfg,const char *name,const char *value,const char *desc)
{
	char *c;
	int i;
	double f;
	qatom_t a;
	int sn=QL_SymbolDef(name);
	ql_symbol_t *s=QL_Symbol(sn);

	QL_SymbolCVar_Define(cfg,sn,desc);

	if (value)
	{
		i=strtol(value,&c,0);
		if (!*c)
		{
			a.type=QAT_INT;
			a.x.i=i;
		}
		else
		{
			f=strtod(value,&c);
			if (!*c)
			{
				a.type=QAT_FLOAT;
				a.x.f=f;
			}
			else
			{
				a.type=QAT_STRING;
				a.x.string=value; /* This is OK, since it will be duplicated anyway */
			}
		}
		QL_SymbolCVar_Default(cfg,sn,a);
	}

	return s->cv;
}


config_var_t *Cfg_FindVar(const char *name)
{
	ql_symbol_t *s=QL_Symbol(QL_SymbolDef(name));
	return s->cv;
}


void Cfg_SetInt(config_var_t *c,int i)
{
	qatom_t a;

	a.type=QAT_INT;
	a.x.i=i;
	QL_SymbolSet(c->symbol,a);
}

void Cfg_SetFloat(config_var_t *c,float f)
{
	qatom_t a;

	a.type=QAT_FLOAT;
	a.x.f=f;
	QL_SymbolSet(c->symbol,a);
}

void Cfg_SetStr(config_var_t *c,const char *str)
{
	qatom_t a;

	a.type=QAT_STRING;
	a.x.string=str;
	QL_SymbolSet(c->symbol,a);
}

