#ifndef GAME_REG_H
#define GAME_REG_H


typedef struct
{
   const char *name;

   struct
   {
      int (*load)(const char *fname);
      int (*save)(const char *fname);
   } map;

   struct
   {
      int (*init)(texdef_t *t);
      void (*free)(texdef_t *t);
      int (*copy)(texdef_t *dst,const texdef_t *src);
   } texdef;
} game_reg_t;


/* returns 0 if a game is already loaded */
int G_Load(game_reg_t *g);

void G_Unload(void);

#endif

