/*
geom.h file of the Quest Source Code

Copyright 1997, 1998 Alexander Malmberg
Copyright 1996, Trey Harrison and Chris Carollo

This program is distributed under the GNU General Public License.
See legal.txt for more information.
*/

#ifndef GEOM_H
#define GEOM_H


#define VEC_Add(dst,v1,v2) do { (dst).x=(v1).x+(v2).x; (dst).y=(v1).y+(v2).y; (dst).z=(v1).z+(v2).z; } while (0)
#define VEC_Sub(dst,v1,v2) do { (dst).x=(v1).x-(v2).x; (dst).y=(v1).y-(v2).y; (dst).z=(v1).z-(v2).z; } while (0)


#define VEC_CheckMin(min,v) \
   do { \
      if ((v).x<(min).x) (min).x=(v).x; \
      if ((v).y<(min).y) (min).y=(v).y; \
      if ((v).z<(min).z) (min).z=(v).z; \
   } while (0)
#define VEC_CheckMax(max,v) \
   do { \
      if ((v).x>(max).x) (max).x=(v).x; \
      if ((v).y>(max).y) (max).y=(v).y; \
      if ((v).z>(max).z) (max).z=(v).z; \
   } while (0)


#define CrossProd(v1,v2,normal) \
   do { \
	   (normal)->x = ((v1).y * (v2).z) - ((v2).y * (v1).z); \
   	(normal)->y = ((v1).z * (v2).x) - ((v2).z * (v1).x); \
   	(normal)->z = ((v1).x * (v2).y) - ((v2).x * (v1).y); \
   } while (0)

#define DotProd(v1,v2) ((v1).x*(v2).x+(v1).y*(v2).y+(v1).z*(v2).z)

#define VEC_FlipPlane(dst,src) \
   do { \
      (dst).dist=-(src).dist; \
      (dst).n.x=-(src).n.x; \
      (dst).n.y=-(src).n.y; \
      (dst).n.z=-(src).n.z; \
   } while (0)


void _CrossProd(vec3_t v1, vec3_t v2, vec3_t *normal);
scalar_t _DotProd(vec3_t v1, vec3_t v2);

scalar_t Sign(scalar_t num);
void Normalize(vec3_t *v);

#endif

