#ifndef HOOK_H
#define HOOK_H

/*
TODO: update

For hooks, HOOK_ALL means all functions attached to the hook will be called.
HOOK_HANDLE means that functions will be called until one of them handles
the call, i.e. returns a non-zero value.

For hook functions, HOOK_FUNC_VOID means that the function returns void, and
HOOK_FUNC_INT returns int. If a HOOK_FUNC_VOID function is called in a
HOOK_HANDLE hook, the return value is assumed to be 1.

For HOOK_HANDLE, Hook_Call will return the value from the last function to
run, or 0 if no function handled the call. For HOOK_ALL, the return value
is always 0.
*/

#define Hook_Call(x,y)

#ifdef FIGURED_OUT_HOW_THIS_SHOULD_WORK

#define HOOK_CALL_ALL     1
#define HOOK_CALL_HANDLE  2


typedef struct hook_s hook_t;


void Hook_Init(void);

hook_t *Hook_Define(const char *name,int type);

hook_t *Hook_Lookup(const char *name);

struct plugin_s;
void Hook_AddFunc(hook_t *h,int type,hook_func_void_t f,void *data,struct plugin_s *p);
void Hook_AddFuncLast(hook_t *h,int type,hook_func_void_t f,void *data,struct plugin_s *p);

int Hook_RemoveFunc(hook_t *h,hook_func_void_t f);
int Hook_RemoveFuncData(hook_t *h,hook_func_void_t f,void *data);
int Hook_RemovePlugin(hook_t *h,struct plugin_s *p);

int Hook_Call(hook_t *h,void *param);

#include "hooks.h"

#endif

#if OLD_STUFF
/*
For hooks, HOOK_ALL means all functions attached to the hook will be called.
HOOK_HANDLE means that functions will be called until one of them handles
the call, i.e. returns a non-zero value.

For hook functions, HOOK_FUNC_VOID means that the function returns void, and
HOOK_FUNC_INT returns int. If a HOOK_FUNC_VOID function is called in a
HOOK_HANDLE hook, the return value is assumed to be 1.

For HOOK_HANDLE, Hook_Call will return the value from the last function to
run, or 0 if no function handled the call. For HOOK_ALL, the return value
is always 0.
*/

#define HOOK_CALL_ALL     1
#define HOOK_CALL_HANDLE  2

#define HOOK_FUNC_VOID    1
#define HOOK_FUNC_INT     2

typedef void (*hook_func_void_t)(void *param,void *data);
typedef int (*hook_func_int_t)(void *param,void *data);


typedef struct hook_s hook_t;


void Hook_Init(void);

hook_t *Hook_Define(const char *name,int type);

hook_t *Hook_Lookup(const char *name);

struct plugin_s;
void Hook_AddFunc(hook_t *h,int type,hook_func_void_t f,void *data,struct plugin_s *p);
void Hook_AddFuncLast(hook_t *h,int type,hook_func_void_t f,void *data,struct plugin_s *p);

int Hook_RemoveFunc(hook_t *h,hook_func_void_t f);
int Hook_RemoveFuncData(hook_t *h,hook_func_void_t f,void *data);
int Hook_RemovePlugin(hook_t *h,struct plugin_s *p);

int Hook_Call(hook_t *h,void *param);

#include "hooks.h"
#endif

#endif

