#ifndef QSYMBOL_H
#define QSYMBOL_H

#include "qatom.h"

typedef struct config_var_s
{
	struct config_s *cfg;
	qatom_t vdefault;
	const char *description;
	int symbol;

/* 'global' value for internal cvar:s (defined with NULL configuration) */
	qatom_t g_vdefault,g_value;

	int state;
/* a bit messy, but basically:

 0 : defined+value+default
 1 : defined
 2 : value
 3 : value+default
 4 : value+defined

 5 : global+value+default
 6 : global+value

in one cfg:

cvar_define : no cv->1, 0,1->error, 2->4, 3->0, 4->error
cvar_default : no cv->3, 0->error, 1->0, 2->3, 3->error, 4->0
cvar_set : no cv->2, 0->0, 1->4, 2->2, 3->3, 4->4
cvar_undef : 0,1,2,3,4->no cv

in second cfg (first cfg is 'Quest', state is 0)

cvar_define : error
cvar_default : 0->5, 5->error, 6->5
cvar_set : 0->6, 5->5, 6->6
cvar_undef : 5,6->0

*/


/* For easy reference */
	char *s;
	int i;
	float f;
} config_var_t;

typedef struct
{
	int lchild,rchild,next; /* used internally */
	qatom_t *a;
	struct config_var_s *cv;
	char name[0];
} ql_symbol_t;

extern int ql_symbols_size;

int QL_SymbolDef(const char *name);
const char *QL_SymbolName(int s);
ql_symbol_t *QL_Symbol(int s);

struct func_s;
void QL_SymbolSetFunc(int s,struct func_s *f);
void QL_SymbolSet(int symbol,qatom_t value);

void QL_SymbolBalance(void);


void QL_SymbolCVar_Define(struct config_s *cfg,int symbol,const char *desc);
void QL_SymbolCVar_Default(struct config_s *cfg,int symbol,qatom_t vdefault);
void QL_SymbolCVar_Set(struct config_s *cfg,int symbol,qatom_t value);
void QL_SymbolCVar_Undef(int symbol);

#endif

