#ifndef SEL_H
#define SEL_H

vsel_t *Sel_FindVert(const sel_t *s,struct brush_s *b,int num);
fsel_t *Sel_FindFace(const sel_t *s,struct brush_s *b,int num);
bsel_t *Sel_FindBrush(const sel_t *s,struct brush_s *b);
esel_t *Sel_FindEnt(const sel_t *s,entity_t *e);

void Sel_AddVert(sel_t *s,struct brush_s *b,int num);
void Sel_AddFace(sel_t *s,struct brush_s *b,int num);
void Sel_AddBrush(sel_t *s,struct brush_s *b);
void Sel_AddEnt(sel_t *s,entity_t *e);

/* Fast versions, these don't check if the thing to be added is already in
the list. */
void Sel_FAddVert(sel_t *s,struct brush_s *b,int num);
void Sel_FAddFace(sel_t *s,struct brush_s *b,int num);
void Sel_FAddBrush(sel_t *s,struct brush_s *b);
void Sel_FAddEnt(sel_t *s,entity_t *e);

void Sel_RemoveVert(sel_t *s,vsel_t *vs);
void Sel_RemoveFace(sel_t *s,fsel_t *fs);
void Sel_RemoveBrush(sel_t *s,bsel_t *bs);
void Sel_RemoveEnt(sel_t *s,esel_t *es);

void Sel_Clear(sel_t *s);
void Sel_Free(sel_t *s); /* Like Sel_Clear, but frees objects pointed at */

void Sel_AddDisp(sel_t *s);
void Sel_RemoveDisp(sel_t *s);
void Sel_Update(sel_t *s);

#endif

